#ifndef COMMONTHREAD_H
#define COMMONTHREAD_H

#include <iostream>
#include <vector>
#include <sstream>

#include <cc++/thread.h>
#include <boost/shared_ptr.hpp>

#include "Element.h"
#include "SimpleQueue.h"

using namespace std;
using namespace ost;
using namespace boost;

typedef shared_ptr<SimpleQueue> SimpleQueuePtr;
typedef shared_ptr<Element> ElementPtr;

class CommonThread : public Thread {
private:
	SimpleQueuePtr queue;
		
public:
	CommonThread(SimpleQueuePtr queue);
	~CommonThread();
	void run();
};

typedef shared_ptr<CommonThread> ThreadPtr;

#endif // COMMONTHREAD_H
