#ifndef SIMPLEQUEUE_H
#define SIMPLEQUEUE_H

#include <iostream>
#include <vector>
#include <sstream>

#include <cc++/thread.h>
#include <boost/shared_ptr.hpp>

#include "Element.h"

using namespace std;
using namespace ost;
using namespace boost;

typedef shared_ptr<Element> ElementPtr;

class SimpleQueue{
private:
	ElementPtr retElem;
	vector <ElementPtr> Queue;
	vector<ElementPtr>::iterator iter;

public:
	Mutex threadMutex;
	SimpleQueue();
	virtual ~SimpleQueue();
	ElementPtr pop();
};

#endif // SIMPLEQUEUE_H
