#include "SimpleQueue.h"

SimpleQueue::SimpleQueue()
{
	
	// Populate the vector with 10000 elements
	for(int i=0; i < 10000; i++) {
		ostringstream oss;	
		oss << i;
		ElementPtr elem = ElementPtr(new Element(oss.str()));
		Queue.push_back(elem);
	}
	cout << "Populated queue with 10000 elements..." << endl;
}

SimpleQueue::~SimpleQueue() {
}

ElementPtr SimpleQueue::pop() {

// *** note 'retElem' is now a member variable of SimpleQueue ***
	
	threadMutex.enterMutex();

	if(!Queue.empty()) { 
		retElem = Queue.back();
		Queue.pop_back();
	} else {
		cout <<"******************* EMPTY QUEUE" << endl;
		retElem.reset();
	}	
	
	threadMutex.leaveMutex();	
	return retElem;
}
